
/**
 * Thrown to indicate that another Enum instance has already
 * been constructed for the specified class and id.
 * This is to prevent accidental declaration of two enums
 * with the same value.
 *
 * @author R Evan Easton
 * @see Enum
 */
public class DuplicateEnumIdException
	extends RuntimeException
{
	/**
	 * Non-public ctor that only Enum really needs
	 */
	DuplicateEnumIdException(Class cls, Object id)
	{
		super("An enum for class " + cls.getName() + " is already registered for id " + id + ".");
	}
}