
import java.io.InvalidObjectException;

/**
 * Throws during Enum deserialization if an id is found that does not
 * map onto one of the declared Enum id's for the class in question.
 *
 * @author R Evan Easton
 */
public class NonExistentEnumException
	extends InvalidObjectException
{
	/**
	 * Non-public ctor that only Enum really needs
	 */
	NonExistentEnumException(Class cls, Object id)
	{
		super("The enum for class " + cls.getName() + " and id " + id + " no longer exists but was found during deserialization.");
	}
}